# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ClustersValidateBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'address': 'str',
        'auth_credentials_link': 'str',
        'ca_certificate': 'str',
        'cluster_type': 'str',
        'created_millis': 'int',
        'credentials': 'Cmxapiresourcesk8sclustersCredentials',
        'custom_properties': 'dict(str, object)',
        'description': 'str',
        'direct_connection': 'bool',
        'endpoint_id': 'str',
        'external_link': 'str',
        '_global': 'bool',
        'id': 'str',
        'installer_id': 'str',
        'kubernetes_worker_instances': 'int',
        'last_operation': 'str',
        'last_operation_message': 'str',
        'last_operation_status': 'str',
        'last_refreshed_millis': 'int',
        'name': 'str',
        'nodes': 'list[Cmxapiresourcesk8sclustersNodes]',
        'org_id': 'str',
        'owner': 'str',
        'project_id': 'str',
        'remaining_unreachable_retry_threshold': 'int',
        'shared': 'bool',
        'status': 'str',
        'updated_millis': 'int',
        'version': 'str'
    }

    attribute_map = {
        'address': 'address',
        'auth_credentials_link': 'authCredentialsLink',
        'ca_certificate': 'caCertificate',
        'cluster_type': 'clusterType',
        'created_millis': 'createdMillis',
        'credentials': 'credentials',
        'custom_properties': 'customProperties',
        'description': 'description',
        'direct_connection': 'directConnection',
        'endpoint_id': 'endpointId',
        'external_link': 'externalLink',
        '_global': 'global',
        'id': 'id',
        'installer_id': 'installerId',
        'kubernetes_worker_instances': 'kubernetesWorkerInstances',
        'last_operation': 'lastOperation',
        'last_operation_message': 'lastOperationMessage',
        'last_operation_status': 'lastOperationStatus',
        'last_refreshed_millis': 'lastRefreshedMillis',
        'name': 'name',
        'nodes': 'nodes',
        'org_id': 'orgId',
        'owner': 'owner',
        'project_id': 'projectId',
        'remaining_unreachable_retry_threshold': 'remainingUnreachableRetryThreshold',
        'shared': 'shared',
        'status': 'status',
        'updated_millis': 'updatedMillis',
        'version': 'version'
    }

    def __init__(self, address=None, auth_credentials_link=None, ca_certificate=None, cluster_type=None, created_millis=None, credentials=None, custom_properties=None, description=None, direct_connection=None, endpoint_id=None, external_link=None, _global=None, id=None, installer_id=None, kubernetes_worker_instances=None, last_operation=None, last_operation_message=None, last_operation_status=None, last_refreshed_millis=None, name=None, nodes=None, org_id=None, owner=None, project_id=None, remaining_unreachable_retry_threshold=None, shared=None, status=None, updated_millis=None, version=None):  # noqa: E501
        """ClustersValidateBody - a model defined in Swagger"""  # noqa: E501
        self._address = None
        self._auth_credentials_link = None
        self._ca_certificate = None
        self._cluster_type = None
        self._created_millis = None
        self._credentials = None
        self._custom_properties = None
        self._description = None
        self._direct_connection = None
        self._endpoint_id = None
        self._external_link = None
        self.__global = None
        self._id = None
        self._installer_id = None
        self._kubernetes_worker_instances = None
        self._last_operation = None
        self._last_operation_message = None
        self._last_operation_status = None
        self._last_refreshed_millis = None
        self._name = None
        self._nodes = None
        self._org_id = None
        self._owner = None
        self._project_id = None
        self._remaining_unreachable_retry_threshold = None
        self._shared = None
        self._status = None
        self._updated_millis = None
        self._version = None
        self.discriminator = None
        if address is not None:
            self.address = address
        if auth_credentials_link is not None:
            self.auth_credentials_link = auth_credentials_link
        if ca_certificate is not None:
            self.ca_certificate = ca_certificate
        if cluster_type is not None:
            self.cluster_type = cluster_type
        if created_millis is not None:
            self.created_millis = created_millis
        if credentials is not None:
            self.credentials = credentials
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if description is not None:
            self.description = description
        if direct_connection is not None:
            self.direct_connection = direct_connection
        if endpoint_id is not None:
            self.endpoint_id = endpoint_id
        if external_link is not None:
            self.external_link = external_link
        if _global is not None:
            self._global = _global
        if id is not None:
            self.id = id
        if installer_id is not None:
            self.installer_id = installer_id
        if kubernetes_worker_instances is not None:
            self.kubernetes_worker_instances = kubernetes_worker_instances
        if last_operation is not None:
            self.last_operation = last_operation
        if last_operation_message is not None:
            self.last_operation_message = last_operation_message
        if last_operation_status is not None:
            self.last_operation_status = last_operation_status
        if last_refreshed_millis is not None:
            self.last_refreshed_millis = last_refreshed_millis
        if name is not None:
            self.name = name
        if nodes is not None:
            self.nodes = nodes
        if org_id is not None:
            self.org_id = org_id
        if owner is not None:
            self.owner = owner
        if project_id is not None:
            self.project_id = project_id
        if remaining_unreachable_retry_threshold is not None:
            self.remaining_unreachable_retry_threshold = remaining_unreachable_retry_threshold
        if shared is not None:
            self.shared = shared
        if status is not None:
            self.status = status
        if updated_millis is not None:
            self.updated_millis = updated_millis
        if version is not None:
            self.version = version

    @property
    def address(self):
        """Gets the address of this ClustersValidateBody.  # noqa: E501


        :return: The address of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this ClustersValidateBody.


        :param address: The address of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._address = address

    @property
    def auth_credentials_link(self):
        """Gets the auth_credentials_link of this ClustersValidateBody.  # noqa: E501


        :return: The auth_credentials_link of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._auth_credentials_link

    @auth_credentials_link.setter
    def auth_credentials_link(self, auth_credentials_link):
        """Sets the auth_credentials_link of this ClustersValidateBody.


        :param auth_credentials_link: The auth_credentials_link of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._auth_credentials_link = auth_credentials_link

    @property
    def ca_certificate(self):
        """Gets the ca_certificate of this ClustersValidateBody.  # noqa: E501


        :return: The ca_certificate of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._ca_certificate

    @ca_certificate.setter
    def ca_certificate(self, ca_certificate):
        """Sets the ca_certificate of this ClustersValidateBody.


        :param ca_certificate: The ca_certificate of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._ca_certificate = ca_certificate

    @property
    def cluster_type(self):
        """Gets the cluster_type of this ClustersValidateBody.  # noqa: E501


        :return: The cluster_type of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._cluster_type

    @cluster_type.setter
    def cluster_type(self, cluster_type):
        """Sets the cluster_type of this ClustersValidateBody.


        :param cluster_type: The cluster_type of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._cluster_type = cluster_type

    @property
    def created_millis(self):
        """Gets the created_millis of this ClustersValidateBody.  # noqa: E501


        :return: The created_millis of this ClustersValidateBody.  # noqa: E501
        :rtype: int
        """
        return self._created_millis

    @created_millis.setter
    def created_millis(self, created_millis):
        """Sets the created_millis of this ClustersValidateBody.


        :param created_millis: The created_millis of this ClustersValidateBody.  # noqa: E501
        :type: int
        """

        self._created_millis = created_millis

    @property
    def credentials(self):
        """Gets the credentials of this ClustersValidateBody.  # noqa: E501


        :return: The credentials of this ClustersValidateBody.  # noqa: E501
        :rtype: Cmxapiresourcesk8sclustersCredentials
        """
        return self._credentials

    @credentials.setter
    def credentials(self, credentials):
        """Sets the credentials of this ClustersValidateBody.


        :param credentials: The credentials of this ClustersValidateBody.  # noqa: E501
        :type: Cmxapiresourcesk8sclustersCredentials
        """

        self._credentials = credentials

    @property
    def custom_properties(self):
        """Gets the custom_properties of this ClustersValidateBody.  # noqa: E501


        :return: The custom_properties of this ClustersValidateBody.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this ClustersValidateBody.


        :param custom_properties: The custom_properties of this ClustersValidateBody.  # noqa: E501
        :type: dict(str, object)
        """

        self._custom_properties = custom_properties

    @property
    def description(self):
        """Gets the description of this ClustersValidateBody.  # noqa: E501


        :return: The description of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ClustersValidateBody.


        :param description: The description of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def direct_connection(self):
        """Gets the direct_connection of this ClustersValidateBody.  # noqa: E501


        :return: The direct_connection of this ClustersValidateBody.  # noqa: E501
        :rtype: bool
        """
        return self._direct_connection

    @direct_connection.setter
    def direct_connection(self, direct_connection):
        """Sets the direct_connection of this ClustersValidateBody.


        :param direct_connection: The direct_connection of this ClustersValidateBody.  # noqa: E501
        :type: bool
        """

        self._direct_connection = direct_connection

    @property
    def endpoint_id(self):
        """Gets the endpoint_id of this ClustersValidateBody.  # noqa: E501


        :return: The endpoint_id of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._endpoint_id

    @endpoint_id.setter
    def endpoint_id(self, endpoint_id):
        """Sets the endpoint_id of this ClustersValidateBody.


        :param endpoint_id: The endpoint_id of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._endpoint_id = endpoint_id

    @property
    def external_link(self):
        """Gets the external_link of this ClustersValidateBody.  # noqa: E501


        :return: The external_link of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._external_link

    @external_link.setter
    def external_link(self, external_link):
        """Sets the external_link of this ClustersValidateBody.


        :param external_link: The external_link of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._external_link = external_link

    @property
    def _global(self):
        """Gets the _global of this ClustersValidateBody.  # noqa: E501


        :return: The _global of this ClustersValidateBody.  # noqa: E501
        :rtype: bool
        """
        return self.__global

    @_global.setter
    def _global(self, _global):
        """Sets the _global of this ClustersValidateBody.


        :param _global: The _global of this ClustersValidateBody.  # noqa: E501
        :type: bool
        """

        self.__global = _global

    @property
    def id(self):
        """Gets the id of this ClustersValidateBody.  # noqa: E501


        :return: The id of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ClustersValidateBody.


        :param id: The id of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def installer_id(self):
        """Gets the installer_id of this ClustersValidateBody.  # noqa: E501


        :return: The installer_id of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._installer_id

    @installer_id.setter
    def installer_id(self, installer_id):
        """Sets the installer_id of this ClustersValidateBody.


        :param installer_id: The installer_id of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._installer_id = installer_id

    @property
    def kubernetes_worker_instances(self):
        """Gets the kubernetes_worker_instances of this ClustersValidateBody.  # noqa: E501


        :return: The kubernetes_worker_instances of this ClustersValidateBody.  # noqa: E501
        :rtype: int
        """
        return self._kubernetes_worker_instances

    @kubernetes_worker_instances.setter
    def kubernetes_worker_instances(self, kubernetes_worker_instances):
        """Sets the kubernetes_worker_instances of this ClustersValidateBody.


        :param kubernetes_worker_instances: The kubernetes_worker_instances of this ClustersValidateBody.  # noqa: E501
        :type: int
        """

        self._kubernetes_worker_instances = kubernetes_worker_instances

    @property
    def last_operation(self):
        """Gets the last_operation of this ClustersValidateBody.  # noqa: E501


        :return: The last_operation of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._last_operation

    @last_operation.setter
    def last_operation(self, last_operation):
        """Sets the last_operation of this ClustersValidateBody.


        :param last_operation: The last_operation of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._last_operation = last_operation

    @property
    def last_operation_message(self):
        """Gets the last_operation_message of this ClustersValidateBody.  # noqa: E501


        :return: The last_operation_message of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._last_operation_message

    @last_operation_message.setter
    def last_operation_message(self, last_operation_message):
        """Sets the last_operation_message of this ClustersValidateBody.


        :param last_operation_message: The last_operation_message of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._last_operation_message = last_operation_message

    @property
    def last_operation_status(self):
        """Gets the last_operation_status of this ClustersValidateBody.  # noqa: E501


        :return: The last_operation_status of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._last_operation_status

    @last_operation_status.setter
    def last_operation_status(self, last_operation_status):
        """Sets the last_operation_status of this ClustersValidateBody.


        :param last_operation_status: The last_operation_status of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._last_operation_status = last_operation_status

    @property
    def last_refreshed_millis(self):
        """Gets the last_refreshed_millis of this ClustersValidateBody.  # noqa: E501


        :return: The last_refreshed_millis of this ClustersValidateBody.  # noqa: E501
        :rtype: int
        """
        return self._last_refreshed_millis

    @last_refreshed_millis.setter
    def last_refreshed_millis(self, last_refreshed_millis):
        """Sets the last_refreshed_millis of this ClustersValidateBody.


        :param last_refreshed_millis: The last_refreshed_millis of this ClustersValidateBody.  # noqa: E501
        :type: int
        """

        self._last_refreshed_millis = last_refreshed_millis

    @property
    def name(self):
        """Gets the name of this ClustersValidateBody.  # noqa: E501


        :return: The name of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ClustersValidateBody.


        :param name: The name of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def nodes(self):
        """Gets the nodes of this ClustersValidateBody.  # noqa: E501


        :return: The nodes of this ClustersValidateBody.  # noqa: E501
        :rtype: list[Cmxapiresourcesk8sclustersNodes]
        """
        return self._nodes

    @nodes.setter
    def nodes(self, nodes):
        """Sets the nodes of this ClustersValidateBody.


        :param nodes: The nodes of this ClustersValidateBody.  # noqa: E501
        :type: list[Cmxapiresourcesk8sclustersNodes]
        """

        self._nodes = nodes

    @property
    def org_id(self):
        """Gets the org_id of this ClustersValidateBody.  # noqa: E501


        :return: The org_id of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this ClustersValidateBody.


        :param org_id: The org_id of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def owner(self):
        """Gets the owner of this ClustersValidateBody.  # noqa: E501


        :return: The owner of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this ClustersValidateBody.


        :param owner: The owner of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._owner = owner

    @property
    def project_id(self):
        """Gets the project_id of this ClustersValidateBody.  # noqa: E501


        :return: The project_id of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this ClustersValidateBody.


        :param project_id: The project_id of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def remaining_unreachable_retry_threshold(self):
        """Gets the remaining_unreachable_retry_threshold of this ClustersValidateBody.  # noqa: E501


        :return: The remaining_unreachable_retry_threshold of this ClustersValidateBody.  # noqa: E501
        :rtype: int
        """
        return self._remaining_unreachable_retry_threshold

    @remaining_unreachable_retry_threshold.setter
    def remaining_unreachable_retry_threshold(self, remaining_unreachable_retry_threshold):
        """Sets the remaining_unreachable_retry_threshold of this ClustersValidateBody.


        :param remaining_unreachable_retry_threshold: The remaining_unreachable_retry_threshold of this ClustersValidateBody.  # noqa: E501
        :type: int
        """

        self._remaining_unreachable_retry_threshold = remaining_unreachable_retry_threshold

    @property
    def shared(self):
        """Gets the shared of this ClustersValidateBody.  # noqa: E501


        :return: The shared of this ClustersValidateBody.  # noqa: E501
        :rtype: bool
        """
        return self._shared

    @shared.setter
    def shared(self, shared):
        """Sets the shared of this ClustersValidateBody.


        :param shared: The shared of this ClustersValidateBody.  # noqa: E501
        :type: bool
        """

        self._shared = shared

    @property
    def status(self):
        """Gets the status of this ClustersValidateBody.  # noqa: E501


        :return: The status of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ClustersValidateBody.


        :param status: The status of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def updated_millis(self):
        """Gets the updated_millis of this ClustersValidateBody.  # noqa: E501


        :return: The updated_millis of this ClustersValidateBody.  # noqa: E501
        :rtype: int
        """
        return self._updated_millis

    @updated_millis.setter
    def updated_millis(self, updated_millis):
        """Sets the updated_millis of this ClustersValidateBody.


        :param updated_millis: The updated_millis of this ClustersValidateBody.  # noqa: E501
        :type: int
        """

        self._updated_millis = updated_millis

    @property
    def version(self):
        """Gets the version of this ClustersValidateBody.  # noqa: E501


        :return: The version of this ClustersValidateBody.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ClustersValidateBody.


        :param version: The version of this ClustersValidateBody.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ClustersValidateBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ClustersValidateBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
